SystemOrganization addCategory: #SmalltalkQuiz!

Object subclass: #AntiSubclassQuizSTQ
	instanceVariableNames: 'choices theClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmalltalkQuiz'!

!AntiSubclassQuizSTQ classSide methodsFor: 'as yet unclassified' stamp: 'hjo 4/14/2010 12:58'!
randomInstance

	^self new beRandom! !

!AntiSubclassQuizSTQ methodsFor: 'as yet unclassified' stamp: 'hjo 4/8/2010 18:07'!
answer

	^theClass! !

!AntiSubclassQuizSTQ methodsFor: 'as yet unclassified' stamp: 'hjo 4/8/2010 18:02'!
beRandom

	| allclasses class choice exchoice |
	allclasses := Smalltalk allClasses.

	allclasses atRandom.
	[class := allclasses atRandom.
	class allSubclasses size < 3 ] whileTrue.

	choice := Set new. 
	[choice add:(class allSubclasses atRandom).
	choice size = 3 ]whileFalse.

	[exchoice := allclasses atRandom.
	class ~= exchoice and: [(class inheritsFrom:exchoice) not].]whileFalse.

	choice add:exchoice.


	self choices: choice asArray shuffled.
	self theClass: class.! !

!AntiSubclassQuizSTQ methodsFor: 'as yet unclassified' stamp: 'hjo 4/8/2010 18:05'!
choices

	^choices! !

!AntiSubclassQuizSTQ methodsFor: 'as yet unclassified' stamp: 'hjo 4/2/2010 17:58'!
choices: aSet 
	
	choices := aSet! !

!AntiSubclassQuizSTQ methodsFor: 'as yet unclassified' stamp: 'hjo 4/8/2010 18:05'!
choicesString

	^'  (1)  ' , (self choices at:1) asString, String cr,
	'  (2)  ' , (self choices at:2) asString, String cr,
	'  (3)  ' , (self choices at:3) asString, String cr,
	'  (4)  ' , (self choices at:4) asString, String cr
! !

!AntiSubclassQuizSTQ methodsFor: 'as yet unclassified' stamp: 'hjo 4/14/2010 13:04'!
correctChoice

	| correctOne |
	correctOne := self choices select: [:each| (each inheritsFrom: self theClass) not].
	self assert: [correctOne size = 1 ].
	^correctOne anyOne! !

!AntiSubclassQuizSTQ methodsFor: 'as yet unclassified' stamp: 'hjo 4/8/2010 18:07'!
indexOfCorrectChoice

	^self choices indexOf: self correctChoice! !

!AntiSubclassQuizSTQ methodsFor: 'as yet unclassified' stamp: 'hjo 4/14/2010 12:55'!
questionAndChoicesString

	^self questionString, String cr, self choicesString.! !

!AntiSubclassQuizSTQ methodsFor: 'as yet unclassified' stamp: 'hjo 4/8/2010 18:04'!
questionString

	^'Which one of the classes below is not subclass of ', theClass asString , '?'! !

!AntiSubclassQuizSTQ methodsFor: 'as yet unclassified' stamp: 'hjo 4/2/2010 17:59'!
theClass: aClass 

	theClass := aClass! !

Object subclass: #CanUnderstandMessageSTQ
	instanceVariableNames: 'theClass choices'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmalltalkQuiz'!

!CanUnderstandMessageSTQ classSide methodsFor: 'as yet unclassified' stamp: 'hjo 4/14/2010 12:53'!
allExistingSelectors

	^(CompiledMethod allInstances collect:[:each| each selector]) asSet! !

!CanUnderstandMessageSTQ classSide methodsFor: 'as yet unclassified' stamp: 'hjo 4/14/2010 12:53'!
randomInstance

	| allSelectors distinguishedSelectors theClass choices instance |
	theClass := Smalltalk allClasses atRandom.
	
	allSelectors := self allExistingSelectors.
	distinguishedSelectors := allSelectors distinguishedBy: [:each| theClass canUnderstand: each].
	choices := Set new.
	choices add: distinguishedSelectors selectedOnes atRandom.
	[choices add: distinguishedSelectors rejectedOnes atRandom.
		choices size < 4 ] whileTrue.
	choices := choices asArray shuffled.

	instance := self new.
	instance theClass: theClass.
	instance choices: choices.
	^instance! !

!CanUnderstandMessageSTQ methodsFor: 'as yet unclassified' stamp: 'hjo 4/12/2010 18:39'!
allSelectors

	^(CompiledMethod allInstances collect:[:each| each selector]) asSet! !

!CanUnderstandMessageSTQ methodsFor: 'as yet unclassified' stamp: 'hjo 4/15/2010 16:14'!
choiceStringAtIndex: aSmallInteger 

	^' (', aSmallInteger printString , ') ' , (self choices at: aSmallInteger)! !

!CanUnderstandMessageSTQ methodsFor: 'as yet unclassified' stamp: 'hjo 4/14/2010 13:28'!
choices

	^choices! !

!CanUnderstandMessageSTQ methodsFor: 'as yet unclassified' stamp: 'hjo 4/14/2010 12:49'!
choices: anArray 

	choices := anArray! !

!CanUnderstandMessageSTQ methodsFor: 'as yet unclassified' stamp: 'hjo 4/12/2010 18:43'!
choicesString

^' (1) ', (choices at:1),'
 (2) ', (choices at:2),'
 (3) ', (choices at:3),'
 (4) ', (choices at:4)! !

!CanUnderstandMessageSTQ methodsFor: 'as yet unclassified' stamp: 'hjo 4/14/2010 12:56'!
questionAndChoicesString

	^self questionString, String cr, self choicesString! !

!CanUnderstandMessageSTQ methodsFor: 'as yet unclassified' stamp: 'hjo 4/12/2010 18:41'!
questionString

	^'Which one of the messages below can be understood by ', theClass printString , '?'! !

!CanUnderstandMessageSTQ methodsFor: 'as yet unclassified' stamp: 'hjo 4/14/2010 12:49'!
theClass: aClass 

	theClass := aClass! !

Object subclass: #SubclassQuizMakerSTQ
	instanceVariableNames: 'allClasses theClass subclassesOfTheClass separatedGroups unshuffledChoices shuffledChoices quiz'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmalltalkQuiz'!

!SubclassQuizMakerSTQ methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2010 09:59'!
doJob

	self selectRandomClassThatHasAtLeastOneSubclass.
	self separateClassesIntoTwoGrouopsOneWithSubclassOfItOthersWithNotSubclassesOfIt.
	self selectRandomOneClassFromSubclassGroupPutItIntoChoices.
	self selectThreeRandomClassesFromNonSubclassGroupPutItIntoChoices.
	self shuffleTheChoices.
	^self makeQuiz! !

!SubclassQuizMakerSTQ methodsFor: 'as yet unclassified' stamp: 'hjo 4/14/2010 13:14'!
doJobInlined

	[allClasses := Smalltalk allClasses.
	theClass := allClasses atRandom.
	subclassesOfTheClass := theClass allSubclasses.
	subclassesOfTheClass size > 0] whileFalse.

	separatedGroups := allClasses distinguishedBy: [:each| each inheritsFrom: theClass ].
	unshuffledChoices := Set with: separatedGroups selectedOnes atRandom.
	[unshuffledChoices add: separatedGroups rejectedOnes atRandom.
	unshuffledChoices size < 4] whileTrue.

	shuffledChoices := unshuffledChoices asArray shuffled.
	quiz := SubclassQuizSTQ new.
	quiz theClass: theClass.
	quiz choices: shuffledChoices.
	^quiz! !

!SubclassQuizMakerSTQ methodsFor: 'as yet unclassified' stamp: 'hjo 4/14/2010 13:14'!
makeQuiz

	quiz := SubclassQuizSTQ new.
	quiz theClass: theClass.
	^quiz choices: shuffledChoices! !

!SubclassQuizMakerSTQ methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2010 09:50'!
selectRandomClassThatHasAtLeastOneSubclass

	[allClasses := Smalltalk allClasses.
	theClass := allClasses atRandom.
	subclassesOfTheClass := theClass allSubclasses.
	subclassesOfTheClass size > 0] whileFalse! !

!SubclassQuizMakerSTQ methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2010 09:53'!
selectRandomOneClassFromSubclassGroupPutItIntoChoices

	unshuffledChoices := Set with: separatedGroups selectedOnes atRandom! !

!SubclassQuizMakerSTQ methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2010 09:54'!
selectThreeRandomClassesFromNonSubclassGroupPutItIntoChoices

	[unshuffledChoices add: separatedGroups rejectedOnes atRandom.
	unshuffledChoices size < 4] whileTrue! !

!SubclassQuizMakerSTQ methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2010 09:52'!
separateClassesIntoTwoGrouopsOneWithSubclassOfItOthersWithNotSubclassesOfIt

	separatedGroups := allClasses distinguishedBy: [:each| each inheritsFrom: theClass ]! !

!SubclassQuizMakerSTQ methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2010 09:55'!
shuffleTheChoices

	shuffledChoices := unshuffledChoices asArray shuffled! !

Object subclass: #SubclassQuizSTQ
	instanceVariableNames: 'answer choices'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmalltalkQuiz'!

!SubclassQuizSTQ classSide methodsFor: 'as yet unclassified' stamp: 'hjo 4/14/2010 12:38'!
randomInstance

	| allClasses theClass subclassesOfTheClass separatedGroups unshuffledChoices shuffledChoices quiz |
	[allClasses := Smalltalk allClasses.
	theClass := allClasses atRandom.
	subclassesOfTheClass := theClass allSubclasses.
	subclassesOfTheClass size > 0] whileFalse.

	separatedGroups := allClasses distinguishedBy: [:each| each inheritsFrom: theClass ].
	unshuffledChoices := Set with: separatedGroups selectedOnes atRandom.
	[unshuffledChoices add: separatedGroups rejectedOnes atRandom.
	unshuffledChoices size < 4] whileTrue.

	shuffledChoices := unshuffledChoices asArray shuffled.
	quiz := self new.
	quiz theClass: theClass.
	quiz choices: shuffledChoices.
	^quiz! !

!SubclassQuizSTQ methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2010 10:20'!
answer

	^answer! !

!SubclassQuizSTQ methodsFor: 'as yet unclassified' stamp: 'hjo 3/31/2010 23:57'!
answer: aClass 

	answer := aClass! !

!SubclassQuizSTQ methodsFor: 'as yet unclassified' stamp: 'hjo 3/31/2010 21:26'!
choices

	^choices! !

!SubclassQuizSTQ methodsFor: 'as yet unclassified' stamp: 'hjo 3/31/2010 23:59'!
choices: anOrderedCollection 

	choices := anOrderedCollection! !

!SubclassQuizSTQ methodsFor: 'as yet unclassified' stamp: 'hjo 3/31/2010 21:49'!
choicesString

	^'  (1)  ' , (self choices at:1) asString, String cr,
	'  (2)  ' , (self choices at:2) asString, String cr,
	'  (3)  ' , (self choices at:3) asString, String cr,
	'  (4)  ' , (self choices at:4) asString, String cr
! !

!SubclassQuizSTQ methodsFor: 'as yet unclassified' stamp: 'hjo 3/31/2010 21:46'!
correctChoice

	| correctOne |
	correctOne := self choices select: [:each| each inheritsFrom: self answer].
	self assert: [correctOne size = 1 ].
	^correctOne anyOne! !

!SubclassQuizSTQ methodsFor: 'as yet unclassified' stamp: 'hjo 3/31/2010 21:52'!
indexOfCorrectChoice

	^self choices indexOf: self correctChoice! !

!SubclassQuizSTQ methodsFor: 'as yet unclassified' stamp: 'hjo 4/14/2010 12:56'!
questionAndChoicesString

	^self questionString, String cr, self choicesString.! !

!SubclassQuizSTQ methodsFor: 'as yet unclassified' stamp: 'hjo 3/31/2010 21:51'!
questionString

	^'Which one of the classes below is subclass of ', answer asString , '?'! !

!SubclassQuizSTQ methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2010 10:19'!
theClass

	^answer! !

!SubclassQuizSTQ methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2010 10:19'!
theClass: aClass 

	answer := aClass! !

Object subclass: #UnderstandsMessageQuizSTQ
	instanceVariableNames: 'theSelector choices'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmalltalkQuiz'!

!UnderstandsMessageQuizSTQ classSide methodsFor: 'as yet unclassified' stamp: 'hjo 4/14/2010 13:01'!
randomInstance

	^self new doJob! !

!UnderstandsMessageQuizSTQ methodsFor: 'as yet unclassified' stamp: 'hjo 4/8/2010 18:51'!
choices

	^choices! !

!UnderstandsMessageQuizSTQ methodsFor: 'as yet unclassified' stamp: 'hjo 4/8/2010 18:51'!
choicesString

	^'  (1)  ' , (self choices at:1) asString, String cr,
	'  (2)  ' , (self choices at:2) asString, String cr,
	'  (3)  ' , (self choices at:3) asString, String cr,
	'  (4)  ' , (self choices at:4) asString, String cr
! !

!UnderstandsMessageQuizSTQ methodsFor: 'as yet unclassified' stamp: 'hjo 4/8/2010 19:06'!
correctChoice

	| corrects |
	corrects := self choices select: [:each | each canUnderstand: theSelector ].
	self assert: [corrects size = 1].
	^corrects anyOne! !

!UnderstandsMessageQuizSTQ methodsFor: 'as yet unclassified' stamp: 'hjo 4/8/2010 18:48'!
doJob

	| distinguishment choiceSet |
	theSelector := CompiledMethod allInstances atRandom selector.

	[
		distinguishment := Smalltalk allClasses distinguishedBy: [:each| each canUnderstand: 	theSelector ].
		distinguishment selectedOnes size>=1 and: [distinguishment rejectedOnes size>=3]
	] whileFalse.

	choiceSet := Set new.
	choiceSet add: distinguishment selectedOnes atRandom.
	[choiceSet size < 4] whileTrue:
		[choiceSet add: distinguishment rejectedOnes atRandom] .

	choices := choiceSet asArray shuffled! !

!UnderstandsMessageQuizSTQ methodsFor: 'as yet unclassified' stamp: 'hjo 4/8/2010 19:06'!
indexOfCorrectChoice

	^self choices indexOf: self correctChoice! !

!UnderstandsMessageQuizSTQ methodsFor: 'as yet unclassified' stamp: 'hjo 4/14/2010 12:56'!
questionAndChoicesString

	^self questionString, String cr, self choicesString.! !

!UnderstandsMessageQuizSTQ methodsFor: 'as yet unclassified' stamp: 'hjo 4/8/2010 18:53'!
questionString

	^'Which one of classes below can understand message #', theSelector  , '?'! !

!UnderstandsMessageQuizSTQ methodsFor: 'as yet unclassified' stamp: 'hjo 4/8/2010 19:09'!
rightOrWrongIfUserChoosed: aSmallInteger 

	^self indexOfCorrectChoice = aSmallInteger! !

Morph subclass: #ExamMorphSTQ
	instanceVariableNames: 'questionTextMoprh quiz choiceMorphs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmalltalkQuiz'!

!ExamMorphSTQ methodsFor: 'as yet unclassified' stamp: 'hjo 4/15/2010 17:06'!
addChoiceMorph

	|textMorph|
	choiceMorphs isNil ifTrue: 
	[
		choiceMorphs := OrderedCollection new.
	].
	
	textMorph := TextMorph new.
	
	choiceMorphs addLast: textMorph.
	
	self addMorph: textMorph! !

!ExamMorphSTQ methodsFor: 'as yet unclassified' stamp: 'hjo 4/15/2010 16:23'!
addQuestionTextMorph

	questionTextMoprh := TextMorph new.
	self addMorph: questionTextMoprh! !

!ExamMorphSTQ methodsFor: 'as yet unclassified' stamp: 'hjo 4/15/2010 16:50'!
beRounded

	self cornerStyle: #rounded! !

!ExamMorphSTQ methodsFor: 'as yet unclassified' stamp: 'hjo 4/15/2010 17:10'!
choiceMorphHeight

	^60! !

!ExamMorphSTQ methodsFor: 'as yet unclassified' stamp: 'hjo 4/15/2010 16:35'!
extentOfQuestionTextMorph

	^questionTextMoprh extent! !

!ExamMorphSTQ methodsFor: 'as yet unclassified' stamp: 'hjo 4/15/2010 16:16'!
initialize

	super initialize.
	self setExtent.! !

!ExamMorphSTQ methodsFor: 'as yet unclassified' stamp: 'hjo 4/14/2010 13:24'!
makeQuiz

	| quizClasses |
	quizClasses := {AntiSubclassQuizSTQ . CanUnderstandMessageSTQ .
	SubclassQuizSTQ . UnderstandsMessageQuizSTQ}.

	^quizClasses atRandom randomInstance

! !

!ExamMorphSTQ methodsFor: 'as yet unclassified' stamp: 'hjo 4/15/2010 17:11'!
positionChoiceMorphAtIndex: aSmallInteger 

	(choiceMorphs at: aSmallInteger) position: (self left+5) @(self yPositionForChoiceIndex:aSmallInteger)! !

!ExamMorphSTQ methodsFor: 'as yet unclassified' stamp: 'hjo 4/15/2010 16:26'!
positionQuestionTextMorph

	questionTextMoprh position: 10@10 + self position! !

!ExamMorphSTQ methodsFor: 'as yet unclassified' stamp: 'hjo 4/15/2010 16:45'!
setColor

	self color: (Color r:0.1 g:0.4b:0.25 alpha:1)! !

!ExamMorphSTQ methodsFor: 'as yet unclassified' stamp: 'hjo 4/15/2010 16:46'!
setColorOfQuestionTextMorph

	questionTextMoprh textColor: Color white! !

!ExamMorphSTQ methodsFor: 'as yet unclassified' stamp: 'hjo 4/15/2010 16:34'!
setContentsOfQuestionTextMorphWithQuiz

	questionTextMoprh contents: quiz questionString! !

!ExamMorphSTQ methodsFor: 'as yet unclassified' stamp: 'hjo 4/15/2010 16:30'!
setCurrentQuiz
	self shouldBeImplemented! !

!ExamMorphSTQ methodsFor: 'as yet unclassified' stamp: 'hjo 4/15/2010 16:19'!
setExtent

	self extent: 299@236! !

!ExamMorphSTQ methodsFor: 'as yet unclassified' stamp: 'hjo 4/15/2010 16:42'!
setExtentOfQuestionTextMorph

	questionTextMoprh wrapFlag: true.
	questionTextMoprh extent: self extent x @ 100! !

!ExamMorphSTQ methodsFor: 'as yet unclassified' stamp: 'hjo 4/15/2010 16:31'!
setRandomQuiz

	quiz := self makeQuiz! !

!ExamMorphSTQ methodsFor: 'as yet unclassified' stamp: 'hjo 4/15/2010 17:10'!
yPositionForChoiceIndex: aSmallInteger 

	^questionTextMoprh bottom + 10 + (aSmallInteger * self choiceMorphHeight)! !
